/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *	STK502LCD𐧌䂷邽߂Ɏgp֐
 *
 * \par Application note:
 *	AVR065: STK502pLCDײ
 *
 * \par Documentation:
 *	IȺގAxׁ߲A߲אݒAx޲ɂĂreadme.html
 *	B
 *
 * \author
 *	Atmel Corporation: http://www.atmel.com \n
 *	xEҰ: avr@atmel.com
 *
 * $Name: RELEASE_1_1 $
 * $Revision: 1.3 $
 * $RCSfile: LCD_driver.c,v $
 * $Date: 2006/02/16 18:14:01 $  \n
 ******************************************************************************/

// ݸٰ ̧
#include "defines.h"
#include "LCD_driver.h"

union _LCD_status LCD_status = {0x01};				//!< LCD_status={0,0,0,0,0,0,FALSE,TRUE};
unsigned char LCD_timer = LCD_TIMER_SEED;			// LCDXVԊuv(LCDڰђP)
unsigned char LCD_displayData[LCD_REGISTER_COUNT];	//!< LCD\ޯ̧(2dɏ՗p)

//! ASCIILCD\ް(Đ)֕ϊ鎞ɎgpQƕ\
__flash unsigned int LCD_character_table[] =		// `\
{
  0x0A51,		// '*' (?)
  0x2A80,		// '+'
  0x0000,		// ',' (`)
  0x0A00,		// '-'
  0x0000,		// '.' (`)
  0x0000,		// '/' (`)
  0x5559,		// '0'
  0x0118,		// '1'
  0x1e11,		// '2'
  0x1b11,		// '3'
  0x0b50,		// '4'
  0x1b41,		// '5'
  0x1f41,		// '6'
  0x0111,		// '7'
  0x1f51,		// '8'
  0x1b51,		// '9'
  0x0000,		// ':' (`)
  0x0000,		// ';' (`)
  0x0000,		// '<' (`)
  0x0000,		// '=' (`)
  0x0000,		// '>' (`)
  0x0000,		// '?' (`)
  0x0000,		// '@' (`)
  0x0f51,		// 'A' (+ 'a')
  0x3991,		// 'B' (+ 'b')
  0x1441,		// 'C' (+ 'c')
  0x3191,		// 'D' (+ 'd')
  0x1e41,		// 'E' (+ 'e')
  0x0e41,		// 'F' (+ 'f')
  0x1d41,		// 'G' (+ 'g')
  0x0f50,		// 'H' (+ 'h')
  0x2080,		// 'I' (+ 'i')
  0x1510,		// 'J' (+ 'j')
  0x8648,		// 'K' (+ 'k')
  0x1440,		// 'L' (+ 'l')
  0x0578,		// 'M' (+ 'm')
  0x8570,		// 'N' (+ 'n')
  0x1551,		// 'O' (+ 'o')
  0x0e51,		// 'P' (+ 'p')
  0x9551,		// 'Q' (+ 'q')
  0x8e51,		// 'R' (+ 'r')
  0x9021,		// 'S' (+ 's')
  0x2081,		// 'T' (+ 't')
  0x1550,		// 'U' (+ 'u')
  0x4448,		// 'V' (+ 'v')
  0xc550,		// 'W' (+ 'w')
  0xc028,		// 'X' (+ 'x')
  0x2028,		// 'Y' (+ 'y')
  0x5009,		// 'Z' (+ 'z')
  0x0000,		// '[' (`)
  0x0000,		// '\' (`)
  0x0000,		// ']' (`)
  0x0000,		// '^' (`)
  0x0000		// '_' (`)
};

/*! \brief	LCD_displayDataޯ̧ALCD\(ݸށAZWAȂ)
 */
void LCD_Init (void)
{
  LCD_AllSegments( FALSE );						//  ޯ̧
  LCDCRA = (1<<LCDEN);							// LCD@\
  LCD_CONTRAST_LEVEL(LCD_INITIAL_CONTRAST);		// LCDZWِݒ
  // 񓯊۸I,S݂ƑS ݂
  LCDCRB = (1<<LCDCS) | (1<<LCDMUX1) | (1<<LCDMUX0) | (1<<LCDPM2) | (1<<LCDPM1)| (1<<LCDPM0);
  LCDFRR = (1<<LCDPS0);							// LCDOuCLK(lcd)/64=64Hzɐݒ
  LCDCRA |= (1<<LCDIE);							// LCDڰъJn荞݋
}

/*! \brief	LCD_displayDataޯ̧LCD ްi[(ޯ̧LCDڰъJn荞݂ׯ܂B)
 *
 *  \param	c		- LCĎɕ\ׂ(ASCII)
 *  \param	digit	- \ׂLCĎԍ
 */
void LCD_WriteDigit( unsigned char c, unsigned char digit )
{

  unsigned int seg;
  unsigned char i;
  unsigned char mask, nibble;
  unsigned char *ptr;

  // ΉޯĒl(SCC)擾
  seg = 0x0000;							// ޯĒl
  if ( (c >= '*') && (c <= 'z') )		// ͈͓ŁA
  {
	if ( c >= 'a' ) c &= ~0x20;			// ȂA啶֕ϊ
	c -= '*';							// Qƕ\ψʂɕϊ
	seg = LCD_character_table[c];		// ΉޯĒl擾
  }
  else									// ͈͊OŁA
  {
	return;
  }
  // ΉՕl擾
  mask = 0x0F;							// Օl擾
  if ( digit & 0x01 )					// ((1),3,5,7)wŁA
  {
	// (ޗʍœK̂߁Â܂܂ɂĂB)
  }
  else									// ((0),2,4,6)wŁA
  {
	mask = 0xF0;						// Օl擾
  }

  i = digit-2;							// ʒu0ɕύX
  if ( i >= 6 )							// ͈͊OʒuŁA
	return;
  i >>= 1;								// ͈͓ʒuŁALCDDRޯ̧擪ψ(i={0,0,1,1,2,2})ɕύX
  ptr = LCD_displayData + i;			// LCDDRޯ̧Ή擪ʒuwq擾

  i = 4;								// 1ɑ΂LCDDRv평
  do									// 4LCDDRޯ̧XV
  {
	nibble = seg & 0x000F;				// ΉLCDDRpޯĒl̂ݒo
	seg >>= 4;							// pޯĒlŉقֈړ
	if ( digit & 0x01 )					// ŁA
	  nibble <<= 4;						// ΉޯĒlقֈړ
	*ptr = (*ptr & mask) | nibble;		// Ή޲Ă̑ΉٍXV
	ptr += 5;							// ʒuwqis
  } while ( --i );						// 4LCDDR܂Ōp
}

/*! \brief	STK502LCDőSĂS\܂͑S\
 *
 *  \param	input	-  [TRUE;FALSE]=[\;\].
 */
void LCD_AllSegments( unsigned char input )
{
  unsigned char i;
  unsigned char *ptr;

  if( input )							// \wŁA
	input = 0xFF;						// Sޯ=1l擾(0wȂAɑSޯ=0)
  ptr = LCD_displayData;				// LCDDRޯ̧擪ʒuwq擾
  i = 20;								// LCDDRv평
  do			  						// LCDDRޯ̧Sݒ(1)܂͉(0)
  {
	*ptr++ = input;						// LCDDRޯ̧Ή޲Ăݒ(1)܂͉(0)
  } while ( --i );						// SLCDDRޯ̧܂Ōp
}

/*! \brief	LCD_displayDataޯ̧eׯLCD_status.updateComplete׸ނݒ肵܂B
 */
#pragma vector = LCD_SOF_vect
__interrupt void LCD_SOF_interrupt( void )
//#pragma vector = LCD_START_FRAME_vect
//__interrupt void LCD_START_FRAME_interrupt( void )
{
  unsigned char i;
  unsigned char *src, *dest;

  LCD_timer--;								// XVԊuv팸
  if( LCD_timer == 0 )						// XVԊuo߂ŁA
  {
	if( LCD_status.updateRequired == TRUE )	// XVvLŁA
	{
	  LCD_timer = LCD_TIMER_SEED;			// XVԊuvĐݒ
	  LCD_status.updateComplete = TRUE;		// XV׸ސݒ

	  i = 20;								// LCDDRڼ޽擾
	  dest = &pLCDREG;						// LCDDRڼ޽ʒuwq擾
	  src = LCD_displayData;				// LCDDRޯ̧ʒuwq擾
	  do									// ޯ̧eLCDDR֕
	  {
		*dest++ = *src++;					// ΉLCDDRޯ̧lΉLCDDRɕ
	  } while ( --i );						// LCDDRڼ޽p
	}
	else									// XVvȂŁA
	{
	  LCD_timer = 1;						// XVvɑ΂ő̂߂ɍXVԊuv=1ݒ
	  LCD_status.updateComplete = FALSE;	// XV׸މ
	}
  }
}
